<?php
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelTempoProducaoKDSReportHandler extends AReportHandler {
    
    const REL_TEMPO_PRODUCAO_KDS_ANALITICO = 'vnd55013_tempoProducaoKDSAnaliticoDataExporter';
    const REL_TEMPO_PRODUCAO_KDS_SINTETICO = 'vnd55013_tempoProducaoKDSSinteticoDataExporter';
	
	public function buildNewRequest($request, Response $response) {
		$conditions = $this->relService->getParamsAsArray($request);
		
		unset($conditions['NRORG']);		
		unset($conditions['NMFILIAL']);
		unset($conditions['NMPRODUTO']);
		unset($conditions['NMLOJA']);
		
		// Gets conditions that use the operator LIKE
		$likeableConditions = $this->relService->getLikeConditions($request);
		
		// Type of Report
		$isAnalitico = $conditions['isAnalitico'];
		
		// Removes all Likeable conditions from the conditions array
		// So we can use relatorioServices's createNewZeedhiFilterRequestObject's method
		foreach ($likeableConditions as $condition) {
			if(array_key_exists($condition['columnName'], $conditions)) {
				 unset($conditions[$condition['columnName']]);
			}
		}
		
		// Some params
		if(isset($conditions['CDLOJA'])){
				if(is_string($conditions['CDLOJA'])){
					unset($conditions['CDLOJA']);
				}
			}
		$conditions = $this->relService->addParams($conditions, 'CDFILIAL');
		$conditions = $this->relService->addParams($conditions, 'CDSETOR');
		$conditions = $this->relService->addParams($conditions, 'CDPRODUTO');
		$conditions = $this->relService->addParams($conditions, 'CDLOJA');
		$this->relService->setIntervalAsDTINIandDTFIM($conditions, 'DTENTRVENDA', 'DTINI', 'DTFIM');

		// Removes the isAnalitico from the conditions
		unset($conditions['isAnalitico']);
		
		// Defines the report dataSourceName
		$this->dataSourceName = $isAnalitico
				? self::REL_TEMPO_PRODUCAO_KDS_ANALITICO
				: self::REL_TEMPO_PRODUCAO_KDS_SINTETICO;
		
		// Builds a new Zeedhi's FilterCriteria's Request's object, with the remaining conditions
		$newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $conditions); 
		
		// Adds to this new Request, all the likeable conditions
		foreach ($likeableConditions as $condition) {
			$newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
		}
		
		
        return [$newRequest, $response];
	}
}